<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OrigensContactoERP StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:OrigensContactoERP
 * @subpackage Structs
 */
class OrigensContactoERP extends AbstractStructBase
{
    /**
     * The Descricao
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Descricao;
    /**
     * The Origem
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Origem;
    /**
     * The Protegida
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Protegida;
    /**
     * The Sistema
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Sistema;
    /**
     * The VersaoUltAct
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $VersaoUltAct;
    /**
     * Constructor method for OrigensContactoERP
     * @uses OrigensContactoERP::setDescricao()
     * @uses OrigensContactoERP::setOrigem()
     * @uses OrigensContactoERP::setProtegida()
     * @uses OrigensContactoERP::setSistema()
     * @uses OrigensContactoERP::setVersaoUltAct()
     * @param string $descricao
     * @param string $origem
     * @param bool $protegida
     * @param bool $sistema
     * @param string $versaoUltAct
     */
    public function __construct($descricao = null, $origem = null, $protegida = null, $sistema = null, $versaoUltAct = null)
    {
        $this
            ->setDescricao($descricao)
            ->setOrigem($origem)
            ->setProtegida($protegida)
            ->setSistema($sistema)
            ->setVersaoUltAct($versaoUltAct);
    }
    /**
     * Get Descricao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescricao()
    {
        return isset($this->Descricao) ? $this->Descricao : null;
    }
    /**
     * Set Descricao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $descricao
     * @return \StructType\OrigensContactoERP
     */
    public function setDescricao($descricao = null)
    {
        // validation for constraint: string
        if (!is_null($descricao) && !is_string($descricao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($descricao)), __LINE__);
        }
        if (is_null($descricao) || (is_array($descricao) && empty($descricao))) {
            unset($this->Descricao);
        } else {
            $this->Descricao = $descricao;
        }
        return $this;
    }
    /**
     * Get Origem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOrigem()
    {
        return isset($this->Origem) ? $this->Origem : null;
    }
    /**
     * Set Origem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $origem
     * @return \StructType\OrigensContactoERP
     */
    public function setOrigem($origem = null)
    {
        // validation for constraint: string
        if (!is_null($origem) && !is_string($origem)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($origem)), __LINE__);
        }
        if (is_null($origem) || (is_array($origem) && empty($origem))) {
            unset($this->Origem);
        } else {
            $this->Origem = $origem;
        }
        return $this;
    }
    /**
     * Get Protegida value
     * @return bool|null
     */
    public function getProtegida()
    {
        return $this->Protegida;
    }
    /**
     * Set Protegida value
     * @param bool $protegida
     * @return \StructType\OrigensContactoERP
     */
    public function setProtegida($protegida = null)
    {
        // validation for constraint: boolean
        if (!is_null($protegida) && !is_bool($protegida)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($protegida)), __LINE__);
        }
        $this->Protegida = $protegida;
        return $this;
    }
    /**
     * Get Sistema value
     * @return bool|null
     */
    public function getSistema()
    {
        return $this->Sistema;
    }
    /**
     * Set Sistema value
     * @param bool $sistema
     * @return \StructType\OrigensContactoERP
     */
    public function setSistema($sistema = null)
    {
        // validation for constraint: boolean
        if (!is_null($sistema) && !is_bool($sistema)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sistema)), __LINE__);
        }
        $this->Sistema = $sistema;
        return $this;
    }
    /**
     * Get VersaoUltAct value
     * @return string|null
     */
    public function getVersaoUltAct()
    {
        return $this->VersaoUltAct;
    }
    /**
     * Set VersaoUltAct value
     * @param string $versaoUltAct
     * @return \StructType\OrigensContactoERP
     */
    public function setVersaoUltAct($versaoUltAct = null)
    {
        // validation for constraint: string
        if (!is_null($versaoUltAct) && !is_string($versaoUltAct)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($versaoUltAct)), __LINE__);
        }
        $this->VersaoUltAct = $versaoUltAct;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OrigensContactoERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
